open Component_defs

type t = box

let init _ = ()

let rec update_dir b1 b2 =
  let id1 = b1 # id # get in
  let id2 = b2 # id # get in
  Gfx.debug "Collision: %s and %s\n%!"id1 id2;
  match (id1, b1), (id2, b2) with
  | (_, b), ("wall_top", _)
  | ("wall_top", _), (_, b)  ->
    let v = b # velocity # get in
    if v.Vector.y <= 0.0 then
      b # velocity # set Vector.{v with y = -.v.y }

  | (_, b), ("wall_bottom", _)
  | ("wall_bottom", _), (_, b) ->
    let v = b # velocity # get in
    if v.Vector.y > 0.0 then
      b # velocity # set Vector.{v with y = -.v.y }

  | (_, b), ("player1", _)
  | ("player1", _), (_, b) ->
    let v = b # velocity # get in
    if v.Vector.x < 0.0 then
      b # velocity # set Vector.{v with x = -.v.x }

  | (_, b), ("player2", _)
  | ("player2", _), (_, b)  ->
    let v = b # velocity # get in
    if v.Vector.x >0.0 then
      b # velocity # set Vector.{v with x = -.v.x }

  | (_, ("wall_left",_))
  | (("wall_left",_), _)  -> Global.set_scoring 2

  | (_, ("wall_right",_))
  | (("wall_right",_), _)  -> Global.set_scoring 1
  | _ -> ()


let update _ el =
  Seq.iteri (fun i b1 ->
      let v1 = b1 #pos # get in
      let r1 = b1 #rect #get in
      Seq.iteri (fun j b2 ->
          if j > i then
            let v2 = b2 # pos # get in
            let r2 = b2 # rect # get in
            if Rect.intersect v1 r1 v2 r2 then update_dir b1 b2
        ) el
    ) el